notes/urls.py
from django.urls import path
from .views import add_note, index

urlpatterns = [
    path('', index, name='index'),
    path('add-note', add_note, name='add-note')
]

project/urls.py
from django.contrib import admin
from django.urls import include, path, re_path
from login_register.views import login as index
import tasks.urls as tasks
import profile_page.urls as profile
import weekly_schedule.urls as weekly_schedule
import personal_journal.urls as personal_journal
import pesanmotivasi.urls as pesan_motivasi
import notes.urls as notes
import login_register.urls as login_register
import authentication.urls as auth
from .router import router

urlpatterns = [
    path('admin/', admin.site.urls),
    path('notes/', include(notes)),
    path('tasks/',include(tasks)),
    path('profile/', include(profile)),
    path('weekly_schedule/', include(weekly_schedule)),
    path('account/', include(login_register)),
    path('personal_journal/', include(personal_journal)),
    path('motivasi/', include(pesan_motivasi)),
    path('auth/', include(auth)),
    path('api/',include(router.urls)),#khusus personal journal versi app
    re_path(r'^$', index, name='index'),
]

tasks/urls.py
from django.urls import path
from .views import TaskView, ViewTaskView, TaskDeleteView
from .views import get_all_tasks

app_name = "tasks"

urlpatterns = [
    path('', ViewTaskView.as_view(), name="view"),
    path('add-task', TaskView.as_view(), name="task"), 
    path('add-task/<int:pk>', TaskDeleteView.as_view(), name="delete"),
    path('get_all_tasks', get_all_tasks, name='get-all-tasks'),
]

tasks/models.py
from django.db import models
from django.contrib.auth.models import User

class Task(models.Model):
    user = models.ForeignKey(User, on_delete=models.CASCADE)
    name = models.CharField(max_length = 150)
    description = models.CharField(max_length = 30)
    task_date = models.DateField(null=True)
    end_time = models.TimeField(null=True)
    
    
    
    

tasks/forms.py
from django import forms
from django.db.models import fields
from .models import Task


class TaskForm(forms.ModelForm):
	class Meta:
		model = Task
		fields = ['name', 'description', 'task_date', 'end_time']
		error_messages = {
			'required' : 'Please Fill All Required Informations'
		}
		input_attrs = {
			'type' : 'text',
		}

tasks/views.py
from django.shortcuts import render
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import HttpResponse, JsonResponse
from django.views import View
from tasks.forms import TaskForm
from tasks.models import Task
from django.contrib.auth.models import User
from django.contrib.auth.decorators import login_required, user_passes_test
from django.core import serializers
from django.utils.decorators import method_decorator
from django.views.decorators.csrf import csrf_exempt

# from django.shortcuts import render, redirect
# from django.template import loader

@method_decorator(csrf_exempt, name='dispatch')
class TaskView(LoginRequiredMixin, View):
    login_url = '/admin/login/'
    form_class = TaskForm
    def post(self, request, *args, **kwargs):
        if request.is_ajax():
            form = self.form_class(request.POST)
            if form.is_valid():
                fs= form.save(commit=False)
                fs.user= request.user
                fs.save()
                return JsonResponse({"message": "success"})
            return JsonResponse({"message": "Validation failed"})
        return JsonResponse({"message": "Wrong request"})

    def get(self,request, *args, **kwargs):
        return render(request, "form.html", {})

class ViewTaskView(LoginRequiredMixin,View):
    login_url = '/admin/login/'
    def get(self,request, *args, **kwargs):
        tasks = Task.objects.filter(user=User.objects.get(username=request.user))
        return render(request, "view.html", {"tasks":tasks.order_by("task_date", "end_time")})

@method_decorator(csrf_exempt, name='dispatch')
class TaskDeleteView(LoginRequiredMixin,View):
    login_url = '/admin/login/'
    def get(self,request, pk, *args, **kwargs):
        if request.is_ajax():
            task = Task.objects.get(pk=pk)
            task.delete()
            return JsonResponse({"message":"success"})
        return JsonResponse({"message": "Wrong request"})

def get_all_tasks(request):
    all_tasks = Task.objects.all()
    data = serializers.serialize('json', all_tasks)
    return HttpResponse(data, content_type="application/json")

tasks/templates/form.html
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>Note Dote</title>
  {% load static %}
  <link rel = "stylesheet" type= "text/css" href="{% static 'style.css'%}">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
  <style>
    .text-red{
        color: tomato !important;
    }
</style>
</head>

<body>
    <div class = body-form>
        <header>
          <div class="container">
            <div class="header-right">
                <a href="/tasks"><b>View Task</b></a>
                <a href="/tasks/add-task"><b>Add Task</b></a>
            </div>
          </div>
        </header>  
        <div class ="body-container">
          <div class="area"></div><nav class="main-menu">
            <ul>
                <li>
                    <a href="/tasks">
                        <i class="fa fa-home fa-2x"></i>
                        <span class="nav-text">
                            Dashboard
                        </span>
                    </a>
                  
                </li>
                <li class="has-subnav">
                    <a href="/personal_journal">
                        <i class="fa fa-laptop fa-2x"></i>
                        <span class="nav-text">
                            Personal Journal
                        </span>
                    </a>
                    
                </li>
                <li class="has-subnav">
                    <a href="/notes">
                       <i class="fa fa-folder-open fa-2x"></i>
                        <span class="nav-text">
                            Notes
                        </span>
                    </a>
                   
                </li>
                <li>
                    <a href="/motivasi/view_motivasi/">
                        <i class="fa fa-font fa-2x"></i>
                        <span class="nav-text">
                           Quotes
                        </span>
                    </a>
                </li>
                <li>
                   <a href="/weekly_schedule">
                       <i class="fa fa-table fa-2x"></i>
                        <span class="nav-text">
                            Weekly Schedule
                        </span>
                    </a>
                </li>
                <li>
                    <a href="/profile">
                       <i class="fa fa-info fa-2x"></i>
                        <span class="nav-text">
                            Profile
                        </span>
                    </a>
                </li>
            </ul>
  
            <ul class="logout">
                <li>
                   <a href="#">
                         <i class="fa fa-power-off fa-2x"></i>
                        <span class="nav-text">
                            Logout
                        </span>
                    </a>
                </li>  
            </ul>
        </nav>
  <div class="container">
    <div class="row pt-5">
        <div class="col-6 offset-3">
            
            <form id="formTask" action="{% url 'tasks:task'  %}" autocomplete="off">
                {% csrf_token %}
                <div class="row">
                    <div class="col-12">
                        <div class="form-group validate">
                            <label for="name">Task Name</label>
                            <input type="text" name="name" class="form-control" id="name" placeholder="Enter name name">
                            <small class="text-red text-muted mySpan"></small>
                        </div>
                        <div class="form-group validate">
                            <label for="description">Description</label>
                            <input type="text" name="description" class="form-control" id="description" placeholder="Enter task description">
                            <small class="text-red text-muted mySpan"></small>
                        </div>
                        <div class="form-group validate">
                            <label for="task_date">Task date</label>
                            <input type="date" name="task_date" class="form-control" id="task_date">
                            <small class="text-red text-muted mySpan"></small>
                        </div>
                        <div class="form-group validate">
                            <label for="end_time">End time</label>
                            <input type="time" name="end_time" class="form-control" id="end_time">
                            <small class="text-red text-muted mySpan"></small>
                        </div>
                    </div>
                    <div class="col-6">
                        <button type="submit" class="btn btn-primary pl-5 pr-5 btnSave">Save</button>
                    </div>
                </div>
            </form>
        </div>
    </div>
</div>

  <script src="https://code.jquery.com/jquery-3.5.1.js" integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc=" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
  <script>
    $("#formTask").on("submit", function(e){
        e.preventDefault();
        e.stopPropagation();
        var $this = $(this);
        var valid = true;
        $('#formTask input').each(function() {
            let $this = $(this);
            
            if(!$this.val()) {
                valid = false;
                $this.parents('.validate').find('.mySpan').text('The '+$this.attr('name').replace(/[\_]+/g, ' ')+' field is required');
            }
        });
    
        if(valid){
            $(".btnSave").text('Saving....').attr('disabled',true);
            let data = $this.serialize();
            $.ajax({
                url: $this.attr("action"),
                type: "POST",
                data: data,
                dataType: "json", 
                success: function(resp){
                    if(resp.message == "success"){
                        alert("Saved successful");
                        $("#formTask")[0].reset();
                    }
                    else{
                        alert(resp.message);
                    }
                    $(".btnSave").text('Save').attr('disabled',false);
                },
                error: function(resp){
                    console.log("Something went wrong");
                    $(".btnSave").text('Save').attr('disabled',false);
                }
            });
        }
        return false;
    });
</script>
</body>
</html>

tasks/templates/view.html
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta http-equiv="X-UA-Compatible" content="IE=edge">
  <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
  <title>Note Dote</title>
  {% load static %}
  <link rel = "stylesheet" type= "text/css" href="{% static 'style.css'%}">
  <link rel="stylesheet" href="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/css/bootstrap.min.css" integrity="sha384-TX8t27EcRE3e/ihU7zmQxVncDAy5uIKz4rEkgIXeMed4M0jlfIDPvg6uqKI2xXr2" crossorigin="anonymous">
  <style>
    .text-red{
        color: tomato !important;
    }
</style>
</head>

<body>
    <div class = body-index>
        <header>
          <div class="container">
            <div class="header-right">
                <a href="/tasks"><b>View Task</b></a>
                <a href="/tasks/add-task"><b>Add Task</b></a>
            </div>
          </div>
        </header>  
        <div class ="body-container">
          <div class="area"></div><nav class="main-menu">
            <ul>
                <li>
                    <a href="/tasks">
                        <i class="fa fa-home fa-2x"></i>
                        <span class="nav-text">
                            Dashboard
                        </span>
                    </a>
                  
                </li>
                <li class="has-subnav">
                    <a href="/personal_journal">
                        <i class="fa fa-laptop fa-2x"></i>
                        <span class="nav-text">
                            Personal Journal
                        </span>
                    </a>
                    
                </li>
                <li class="has-subnav">
                    <a href="/notes">
                       <i class="fa fa-folder-open fa-2x"></i>
                        <span class="nav-text">
                            Notes
                        </span>
                    </a>
                   
                </li>
                <li>
                    <a href="/motivasi/view_motivasi/">
                        <i class="fa fa-font fa-2x"></i>
                        <span class="nav-text">
                           Quotes
                        </span>
                    </a>
                </li>
                <li>
                   <a href="/weekly_schedule">
                       <i class="fa fa-table fa-2x"></i>
                        <span class="nav-text">
                            Weekly Schedule
                        </span>
                    </a>
                </li>
                <li>
                    <a href="/profile">
                       <i class="fa fa-info fa-2x"></i>
                        <span class="nav-text">
                            Profile
                        </span>
                    </a>
                </li>
            </ul>
  
            <ul class="logout">
                <li>
                   <a href="#">
                         <i class="fa fa-power-off fa-2x"></i>
                        <span class="nav-text">
                            Logout
                        </span>
                    </a>
                </li>  
            </ul>
        </nav>
  <!-- Content Wrapper. Contains page content -->
  <div class="container">
    <div class="row pt-5">
        <div class="col-12">
            <p style="font: Raleway;"><b>Upcoming Deadline</b></p>
            <table class="table" id="table">
                <thead>
                  <tr>
                    <th scope="col">Name</th>
                    <th scope="col">Deadline</th>
                    <th scope="col">Description</th>
                    <th scope="col">Actions</th>
                  </tr>
                </thead>
                <tbody>
                    {% for task in tasks %}
                    <tr class="record">
                        <td>{{ task.name }}</td>
                        <td>{{ task.task_date }} {{ task.end_time }}</td>
                        <td>{{ task.description }}</td>
                        <td>
                            <a href="{% url 'tasks:delete' task.id  %}" class="link-delete text-danger">Done</a>
                        </td>
                    </tr>
                    {% endfor %}
                </tbody>
              </table>
        </div>
    </div>
</div>
  <!-- /.content-wrapper -->

  

  <script src="https://code.jquery.com/jquery-3.5.1.js" integrity="sha256-QWo7LDvxbWT2tbbQ97B53yJnYU3WhH/C8ycbRAkjPDc=" crossorigin="anonymous"></script>
  <script src="https://cdn.jsdelivr.net/npm/bootstrap@4.5.3/dist/js/bootstrap.bundle.min.js" integrity="sha384-ho+j7jyWK8fNQe+A12Hb8AhRq26LrZ/JpcUGGOn+Y7RsweNrtN/tE3MoK7ZeZDyx" crossorigin="anonymous"></script>
  <script>
    $(".link-delete").on("click", function(e){
        e.preventDefault();
        var $this = $(this);
        if(confirm("Are you sure you have done this task?")){
            $.ajax({
                url: $this.attr("href"),
                type: "GET",
                dataType: "json",
                success: function(resp){
                    if(resp.message == "success"){
                        $this.parents(".record").fadeOut("slow", function(){
                            $this.parents(".record").remove();
                        });
                    }else{
                        alert(resp.message);
                    }
                }
            });
        }
        return false;
    });
    </script>
</body>
</html>